'use strict';

exports.__esModule = true;
var isPromise = exports.isPromise = function isPromise(value) {
  return value != null && typeof value.then === 'function';
};

var ensureResolved = exports.ensureResolved = function ensureResolved(value) {
  return isPromise(value) ? value : Promise.resolve(value);
};

var ensureRejected = exports.ensureRejected = function ensureRejected(value) {
  return isPromise(value) ? value : Promise.reject(value);
};

var ensurePromise = exports.ensurePromise = function ensurePromise(fn) {
  return function () {
    try {
      return ensureResolved(fn.apply(undefined, arguments));
    } catch (err) {
      return ensureRejected(err);
    }
  };
};